/*

                radioWave mW device

                Cۏ̎WƋL^

	simpleUart.c

	Copyrights 2010,  Yoshi Hiroshi.

 */

#include <avr/io.h>
#include <stdio.h>
#include "simpleUart.h"

int uartPutChar(char c, FILE *stream);
int uartGetChar(FILE *stream);

FILE uart = FDEV_SETUP_STREAM(uartPutChar, uartGetChar, _FDEV_SETUP_RW);

void initUart()
{
    DDRD |= _BV(PD1);
    UCSR0C = _BV(UCSZ01) | _BV(UCSZ00);
    UCSR0B = _BV(RXEN0) | _BV(TXEN0);
    UCSR0A = _BV(U2X0);
    UBRR0 = 21;     // 20MHz/115200 baud 
// stdio
    stdout = stdin = &uart;
    stderr = &uart;
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartPutChar
 *
 *          Xg[֕1o͂
 *
 **********************************************************************/
int uartPutChar(char c, FILE *stream)
{
    loop_until_bit_is_set(UCSR0A, UDRE0);
    UDR0 = c;
    return 0;
}

/**********************************************************************
 *
 *          Standart I/O Interface                  uartGetChar
 *
 *          Xg[當1͂
 *
 **********************************************************************/
int uartGetChar(FILE *stream)
{
  return 0;
}
