/*

        󑐋Z@ʃfBXvC̉p

        Copyright 2009-2011, Yoshi Hiroshi.

*/

#define GET_COLOUR_INT(red,green,blue) \
            ((((((red) & 0xF8) << 5) | \
                ((green) & 0xFC)) << 3) | \
                ((blue) >> 3))

#define COLOUR_BLACK                GET_COLOUR_INT(0, 0, 0)
#define COLOUR_RED                  GET_COLOUR_INT(255, 0, 0)
#define COLOUR_DARK_RED             GET_COLOUR_INT(64, 0, 0)
#define COLOUR_GREEN                GET_COLOUR_INT(0, 255, 0)
#define COLOUR_BLUE                 GET_COLOUR_INT(0, 0, 255)
#define COLOUR_CYAN                 GET_COLOUR_INT(0, 255, 255)
#define MENU_COLOUR                 GET_COLOUR_INT(255, 80, 192)
#define MENU_ITEM_COLOUR            GET_COLOUR_INT(192, 192, 255)
#define MENU_SELECT_ITEM_COLOUR     GET_COLOUR_INT(192, 192, 0)
#define MENU_SEL_MARK_COLOUR        GET_COLOUR_INT(160, 160, 224)
#define MENU_SCOPE_BACK_COLOUR      GET_COLOUR_INT(16, 40, 16)
#define MENU_SEPALATE_LINE_COLOUR   GET_COLOUR_INT(32, 96, 64)
#define MENU_VERTICAL_LINE_COLOUR   GET_COLOUR_INT(32, 128, 32)
#define MENU_GRAPH_LINE_COLOUR      GET_COLOUR_INT(224, 255, 32)
#define MENU_TRIG_HIGH_COLOUR       GET_COLOUR_INT(96, 128, 255)
#define MENU_TRIG_HIGH_DARK_COLOUR  GET_COLOUR_INT(24, 32, 64)
#define MENU_TRIG_LOW_COLOUR        GET_COLOUR_INT(48, 160, 255)
#define MENU_TRIG_LOW_DARK_COLOUR   GET_COLOUR_INT(12, 40, 64)

void uDispErase();
void uDispSetBackgroundColour(unsigned char red, unsigned char green, unsigned char blue);
void uDispSetTextBackground(unsigned char m);
void uDispSetBrightness(unsigned char b);
unsigned char uDispGetBrightness();
void uDispSetFontSize(unsigned char fs);
void uDispSetColour(unsigned char red, unsigned char green, unsigned char blue);
void uDispSetColourInt(unsigned int rgb565);
void uDispDrawText(unsigned char row, unsigned char col, char* str);
void uDispDrawText_P(unsigned char row, unsigned char col, PGM_P str);
void uDispDrawInteger(unsigned char row, unsigned char col, char* format, int val);
void uDispDrawLine(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);
void uDispDrawRectangle(unsigned char fill, unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2);

#define uDispId                         204
#define UDISP_DELAY_VERY_LONG           1000
#define UDISP_DELAY_LONG                300
#define UDISP_DELAY_MIDDLE              60
#define UDISP_DELAY_SHORT               15

#define UDISP_CMND_CLEAR                69
#define UDISP_CMND_TEXT                 115
#define UDISP_CMND_LINE                 76
#define UDISP_CMND_RECTANGLE            114
#define UDISP_CMND_FILL_RECTANGLE       112
#define UDISP_CMND_BACKGROUND           66
#define UDISP_CMND_TEXT_BACKGROUND      79
#define UDISP_CMND_BRIGHTNESS           89

#define UDISP_FONT_SIZE_SMALL           0
#define UDISP_FONT_SIZE_MIDDLE          1
#define UDISP_FONT_SIZE_LARGE           2

#define UDISP_RECT_FILL_OFF             1
#define UDISP_RECT_FILL_ON              0

extern char strWork[12];
